"""
Copyright (C) 2005 Magnus Bjernstad <bjernstad@gmail.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""

import ConfigParser, os

def glade_file(module):
    return get_abs_path(os.path.join("glade", module+".glade"))
    

def get_abs_path(filename):
    dirs = ["data", "/usr/share/shellac", "/usr/local/share/shellac"]
    for dir in dirs:
        full_path = os.path.realpath(os.path.join(dir, filename))
        if os.path.isfile(full_path):
            return full_path
    return None

def format_time(ms, format="%2d:%02d"):
    """
    Format a time in milliseconds to a string mm:ss.
    """
    if ms < 0:
        return "-%s" % (format_time(abs(ms), format),)
    return format % (abs(ms)/60000, (abs(ms)/1000)%60)

def queue_function(player, callback, *args):
    # Call 'callback' when we are done
    handler = CallbackHandler(callback, *args)
    player.client.playback_status(handler)

class CallbackHandler:
    """
    A handler for xmmsclient calls.
    Calls 'callback' in it's handler function.
    """
    def __init__(self, callback=None, *args):
        self.args = args
        self.callback = callback

    def __call__(self, res):
        try:
            self.callback(*self.args)
        except TypeError:
            pass # No callback defined
